# Specfile for NewsXch

%define name	ksm-newsxch
%define version	1.0.1
%define release	1.0.0
%define _arch	noarch
%define _srcfile	%{_topdir}/SOURCES/%{name}.tgz
%define _confdir	/usr/local/etc
%define _scnfdir	/etc/sysconfig
%define _rcdir		/etc/init.d
%define _bindir		/usr/local/bin
%define _rbindir	/root/bin
%define _ubindir	/home/USR/bin
%define _datadir	/usr/local/share/%{name}
%define _icondir	/usr/share/icons/hicolor
%define _man1dir	/usr/local/share/man/man1
%define _man3dir	/usr/local/share/man/man3
%define _man7dir	/usr/local/share/man/man7
%define _man8dir	/usr/local/share/man/man8
%define _docdir		/usr/local/share/doc/packages/%{name}

Summary:	Programs for exchanging news
Name:		%{name}
Version:	%{version}
Release:	%{release}
License:	GPLv2
Group:		Productivity/Networking/News/Utilities
Source:		%{name}.tgz
URL:		http://www.kaesmann-online.de/
#BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root
BuildArch:	%{_arch}
#BuildRequires:	samplepkg,samplecapab
Requires:	inn,suck
Requires:	ksm-lib-sh >= 4.0.0-0.0.0
#Provides:	sampled
Conflicts:	ksm-mail+news
#Obsoletes:	mysampled

%description
This package contains programs for exchanging news.
Enable the news exchange with togglenewsxch -e

Please check/configure:
 /usr/local/etc/news.conf

#---------------------- ALL PACKAGES -----------------------------------------
%install
%{__rm} -rf $RPM_BUILD_ROOT
#%makeinstall or make DESTDIR=$RPM_BUILD_ROOT install
%{__mkdir} $RPM_BUILD_ROOT
%{__tar} -C $RPM_BUILD_ROOT -xpzf %{_srcfile}
%{__rm} -rf $RPM_BUILD_ROOT/help*

%clean
%{__rm} -rf $RPM_BUILD_DIR/*
%{__rm} -rf $RPM_BUILD_ROOT

#-----------------------------------------------------------------------------
%files
#%defattr(-,root,root)
%defattr(0644,root,root)

# use .rpmsave .rpmnew .rpmorig
# In case of (noreplace) modified config will not be overwritten.
# If config has been modified then new file goes to config.rpmnew
#%config(noreplace) %{_confdir}/sample.conf
#%config %{_confdir}/sample.conf
#%config %{_scnfdir}/sample
%{_confdir}/news.conf

#%attr(744,root,root)/%{_rcdir}/sampled

%attr(754,news,news)%{_bindir}/get.news.inn
%attr(754,root,root)%{_bindir}/newsexch
%attr(755,root,root)%{_bindir}/newsq
%attr(754,root,root)%{_bindir}/newsxch
%attr(754,root,root)%{_bindir}/nlocks
%attr(754,root,root)%{_bindir}/togglenewsxch
/etc/logrotate.d/suck

%{_datadir}/RELEASE
%{_datadir}/VERSION

#/usr/share/applications/sample.desktop
#%{_icondir}/16x16/apps/sample.png
#%{_icondir}/22x22/apps/sample.png
#%{_icondir}/32x32/apps/sample.png
#%{_icondir}/48x48/apps/sample.png
#%{_icondir}/64x64/apps/sample.png
#%{_icondir}/128x128/apps/sample.png
#/usr/share/pixmaps/sample.png

%docdir %{_man1dir}
%{_man1dir}/newsq.1.gz

%docdir %{_man8dir}
%{_man8dir}/get.news.inn.8.gz
%{_man8dir}/newsexch.8.gz
%{_man8dir}/newsxch.8.gz
%{_man8dir}/nlocks.8.gz
%{_man8dir}/togglenewsxch.8.gz

%docdir %{_docdir}
%{_docdir}/ChangeLog
%{_docdir}/GPL-2.0.txt
%{_docdir}/LGPL-2.1.txt
%{_docdir}/README
#%{_docdir}/README.de

#-----------------------------------------------------------------------------
%pre
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# disable sample and stop sampled
test -x %{_bindir}/togglenewsxch && %{_bindir}/togglenewsxch -d > /dev/null 2>&1
#test -x %{_rcdir}/newsxchd && %{_rcdir}/newsxchd stop > /dev/null 2>&1

# backup config files
test -e %{_confdir}/news.conf && cp %{_confdir}/news.conf %{_confdir}/news.conf.rpmsave
chmod 600 %{_confdir}/news.conf.rpmsave
#test -e %{_scnfdir}/newsxch && cp %{_scnfdir}/newsxch %{_scnfdir}/newsxch.rpmsave

#if [ "$1" == 1 ]; then					# install package
#else							# upgrade package
#fi
exit 0

#-----------------------------------------------------------------------------
%post
# Arg $1 to this script (count of pkgs after new installation) = 1
# Arg $1 to this script (count of pkgs during upgrade) = 2

# set config pathname and all config vars from new config file
cf=%{_confdir}/news.conf
cnfvars='REMOTE_HOST REMOTE_USER REMOTE_PASS NEXLOCKFILE NELOCKFILE'

# install desktop files
#xdg-desktop-menu install --novendor \
#	/usr/share/applications/sample.directory \
#	/usr/share/applications/sample.desktop \
#	/usr/share/applications/sample-admin.desktop

if [ "$1" == 1 ]; then					# install package
#	# set links to other pkgs
#	ln -sf /usr/bin/prog %{_bindir}/myprog
#
	echo "Configure $cf"
#	echo "Users must create HOME/.samplerc with update-sample"
else							# upgrade package
	# update global conf
	c=''
	s=''
	t=''
	ret=0
	if [ -e $cf.rpmsave ]; then
		#cp $cf $cf.rpmnew
		. $cf
		. $cf.rpmsave
		if [ -x %{_bindir}/replcnfvar ]; then
			for c in $cnfvars; do
				t="\$$c"
				eval s="$t"
				s=\"$s\"
				%{_bindir}/replcnfvar $cf $c "$s"
			done
			chown news:news $cf
			chmod 600 $cf
		else
			echo "Error - cmd replcnfvar not found or not executable!" >&2
			echo "Conf file not updated!" >&2
		fi

#		# update array vars MainArr HelpArr
#		cnt=${#MainArr[@]}			# max index of array
#		i=0
#		if [ "$cnt" -gt 0 ]; then		# any arrays in use?
#			while [ "$i" -lt $cnt ]; do
#				let i++
#				# array MainArr
#				s="MainArr[$i]=\"${MainArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#				# array HelpArr
#				s="HelpArr[$i]=\"${HelpArr[$i]}\""
#				echo "$s" >> $cf	# append to conf file
#			done
#		fi

		diff $cf $cf.rpmsave > /dev/null 2>&1
		ret=$?
		if [ "$ret" -eq 0 ]; then
			rm $cf.rpmsave
		else
			echo "Check $cf"
		fi
	fi

#	echo "If new version then users must update HOME/.samplerc with update-sample"
fi
exit 0

#-----------------------------------------------------------------------------
%preun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

# disable sample and stop sampled
test -x %{_bindir}/togglenewsxch && %{_bindir}/togglenewsxch -d > /dev/null 2>&1
#test -x %{_rcdir}/newsxchd && %{_rcdir}/newsxchd stop > /dev/null 2>&1

if [ "$1" == 0 ]; then					# remove package
#	# backup config files
	test -e %{_confdir}/news.conf && cp %{_confdir}/news.conf %{_confdir}/news.conf.rpmsave
	chmod 600 %{_confdir}/news.conf.rpmsave
#	test -e %{_scnfdir}/news && cp %{_scnfdir}/news %{_scnfdir}/news.rpmsave
#else							# upgrade package
fi
exit 0

#-----------------------------------------------------------------------------
%postun
# Arg $1 to this script (count of pkgs after erasing) = 0
# Arg $1 to this script (count of pkgs after upgrade) = 1

if [ "$1" == 0 ]; then					# remove package
	rmdir --ignore-fail-on-non-empty %{_docdir}
	rmdir --ignore-fail-on-non-empty %{_datadir}
	#rmdir --ignore-fail-on-non-empty /var/lib/sample

	# remove own links to other pkgs
	#test -e %{_bindir}/myprog && rm -f %{_bindir}/myprog

	# remove stuff
	#rmdir /var/lib/sampledir

	# uninstall desktop files
	#xdg-desktop-menu uninstall \
	#	/usr/share/applications/sample.directory \
	#	/usr/share/applications/sample.desktop \
	#	/usr/share/applications/sample-admin.desktop
#else							# upgrade package
	# enable sample and start sampled
	#%{_bindir}/togglesample -e -q > /dev/null 2>&1
	#%{_rcdir}/sampled start > /dev/null 2>&1
fi
exit 0

%changelog
* Thu Jan 06 2022 Repomaster <repomaster@kaesmann-online.de> 1.0.1-1.0.0
- Update to the libfuncstd-sh 4.0.0

* Tue Feb 07 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.1-0.10.0
- All scripts have been revised
  (using function GetOpt).

* Wed Jan 04 2017 Repomaster <repomaster@kaesmann-online.de> 1.0.1-0.9.0
- All scripts have been revised.

* Sun Mar 20 2016 Repomaster <repomaster@kaesmann-online.de> 1.0.1-0.8.0
- The name of the logfile has been changed.

* Wed Oct 15 2014 Repomaster <repomaster@kaesmann-online.de> 1.0.1-0.7.1
- The docu of the package has been revised.

* Wed Apr 03 2013 Juergen Kaesmann <juergen@kaesmann.us> 1.0.1-0.7.0
- The script togglenews has been renamed to togglenewsxch.
- The script togglenewsxch has been revised.

* Fri Sep 28 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.6.0
- The package has been revised.

* Sun May 06 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.5.0
- The config file news.conf has been revised.

* Thu Apr 26 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.4.0
- The config update process has been revised.

* Fri Apr 20 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.3.0
- The RPM scriptlets are revised.

* Thu Apr 19 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.2.0
- The RPM scriptlets are revised.

* Tue Apr 03 2012 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.1.0
- The release naming scheme has changed ('.ksm' is removed).

* Tue Jan 04 2011 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.1.0.ksm
- The package name has changed to avoid conflicts with the openSUSE
  distribution. It has been prepended with 'ksm-'.

* Wed Mar 24 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.1.0.ksm
- The installation dependencies are corrected.

* Tue Feb 02 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.0.4.ksm
- Read version and dependency infos from external files.

* Wed Jan 27 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.0.3.ksm
- The docu has changed.

* Fri Jan 15 2010 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.0.2.ksm
- The package name (Release) has changed.

* Thu Nov 19 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.ksm.0.1
- The RPM scriptlets are corrected.

* Sat Nov 14 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.1-0.ksm.0.0
- The program ne is renamed to newsexch

* Mon Oct 26 2009 Juergen Kaesmann <juergen@kaesman.de> 1.0.0
- The package management has changed to RPM.
